#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

struct buffer_t
{
    float4x4 u_MVP;
    float4x4 u_View;
    float4x4 u_Projection;
};

struct main0_out
{
    float3 v_WorldSpacePos;
    float4 gl_Position [[position]];
};

struct main0_in
{
    float3 attPosition [[attribute(0)]];
};

vertex main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer)
{
    main0_out out = {};
    float4 homogeneous_pos = buffer.u_MVP * float4(in.attPosition, 1.0);
    homogeneous_pos = buffer.u_View * float4(in.attPosition, 0.0);
    homogeneous_pos = buffer.u_Projection * float4(homogeneous_pos.xyz, 1.0);
    out.gl_Position = homogeneous_pos.xyww;
    out.v_WorldSpacePos = in.attPosition;
    out.gl_Position.z = (out.gl_Position.z + out.gl_Position.w) * 0.5;       // Adjust clip-space for Metal
    return out;
}

